
{
Cursor Keys:
Up: $48
Down: $50
Left: $4B
Right: $4D
}


{$G+}
uses playzsm6, sblaster, crt;

  var track: byte;
      titel: string[30];
      t_length: byte absolute titel;
      composer: string[20];
      i,ii: byte;
      fname: string[32];
      key: bytebool;
      ch: char;
      ln10: real;
      db: shortint;
      lastpatpos: word;
      scopecol: word;
      mode: word;
      lastscopecol: byte;
      scopecolchange: bytebool;
      screenbuf: pointer;
      bitsum: word;
      do_pdisplay: bytebool;
      scope_hold: bytebool;
      sample: byte;
      last_sequ: word;
      newpatrow: bytebool;
      last_newpatrow: word;
      errcode: byte;
      traff: word;
      idle: longint;
      txtcol: byte;
      playing_seconds: word;
      actual_seconds: word;
      cmsg_test: pointer;
      message_line: string[40];
      msg_offset: word;
      msg_line: byte;
      msg_linenum: byte;
      msg_len: byte absolute message_line;
      msg_counter: byte;
      fastwr_x, fastwr_y: word;
      fastwr_text: string;
      fastwr_textlen: byte absolute fastwr_text;
      fastwr_col: byte;
      fastwr_rep: word; { nur fr einzelne Zeichen }
      smpdet_start: byte;
      play_looped: bytebool;
      param: string;
      param_len: byte absolute param;
      user_abort: bytebool;
   const bsize = 768;
         flashcol: array[1..6] of byte = (4, 6, 12, 13, 14, 15);
         pattcol: array[0..7] of byte = (0, 1, 1, 9, 2, 3, 10, 11);
         scopetext: string = '-=ZSMPLAY=-';
         scopetext2: string ='scope mode';
         dancecol: array[0..3] of byte = (11, 3, 9, 1);
         month: array[1..12] of string[10] =
         ('January', 'February', 'March', 'April', 'May', 'June', 'July',
          'August', 'September', 'October', 'November', 'December');
         hexnyb: array[0..15] of char = '0123456789ABCDEF';
         scaledvol: array[0..15] of byte =
         (1,2,3,4,6,8,12,16,24,32,48,64,96,128,192,255);
         hex2byte: array[48..70] of byte =
         (0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0,0,10,11,12,13,14,15);

procedure fastwrite; assembler; {schreibt Text direkt in den Bildschirmspeicher }
asm
  mov cx, fastwr_rep
  or cx, cx
  jz @skipall
  mov ax, 0b800h
  mov es, ax
  mov ax, fastwr_y
  shl ax, 7 { x 128 }
  mov di, ax
  shr ax, 2 { x 128 div 4 = x 32 }
  add di, ax { di = 160 x y }
  mov ax, fastwr_x
  add ax, ax
  add di, ax { di = 160 x y + 2 * x }
  { Zielregister sind gesetzt }
  mov bx, di

  lea si, fastwr_text
  mov ah, fastwr_col
  dec cx
  jz @noloop
  inc cx
  mov al, ds:[si+1]
  rep stosw
  jmp @end
  @noloop: { Text nur einmal schreiben }
  xor ch, ch
  mov cl, ds:[si]
  or cl, cl {sicherheitshalber prfen ob string null ist }
  jz @end
  inc si
  @copyloop:
    mov al, ds:[si]
    inc si
    mov es:[di], ax
    add di, 2
    dec cx
  jnz @copyloop
  @end:
  sub di, bx
  shr di, 1
  add fastwr_x, di
  mov fastwr_rep, 1
  @skipall:
end;



procedure display_vu;
  var i: shortint;
  fcol: byte;
  green, yellow, red: byte;
begin

  if vumeter = 0 then db := -128 else
    db := trunc(20 * ln(vumeter / 256) / ln10);

  {gotoxy(41, 19);}
  fastwr_x := 40; fastwr_y := 18;

  if db > 6 then db := 6;

  if db < -29 then begin
   {
   textcolor(3);
   for i := -29 to 6 do write('')
   }

   fastwr_col := 3;
   fastwr_text := '';
   fastwr_rep := 36;
   fastwrite;


  end
  else
  begin

    fastwr_text := '';
    fastwr_col := 10;


    if db < 0 then
    begin
    {
    textcolor(10);
      for i := -29 to db do
        write('');
    }
    fastwr_rep := db + 30; { ! +- 1 }
    fastwrite;
    end;

    if db = 0 then
    begin
    {
    textcolor(10);
      for i := -29 to -1 do
        write('');
    }
    fastwr_rep := 29; {! +- 1 }
    fastwrite;

{    textcolor(14); write('');}
    fastwr_col := 14;
    fastwrite;
    end;

    if db > 0 then
    begin
    {
    textcolor(10);
      for i := -29 to -1 do
        write('');
    }
    fastwr_col := 10;
    fastwr_rep := 29; { ! +- 1 }
    fastwrite;
    {
    textcolor(14); write('');
    }
    fastwr_col := 14;
    fastwrite;
    {
    textcolor(12);
    for i := 1 to db do
      write('');
    }
    fastwr_col := 12;
    fastwr_rep := db;
    fastwrite;
    end;
    {
    textcolor(3);
    for i := db+1 to 6 do
      write('');
    textcolor(7);
    }
    fastwr_text := '';
    fastwr_col := 3;
    fastwr_rep := 6 - db;
    fastwrite;
  end;

  {
  fcol := vumeter div 48;
  if fcol < 1 then fcol := 1;
  if fcol > 6 then fcol := 6;
  textcolor(flashcol[fcol]);
  gotoxy(16, 1); write('-=ZSMPLAY=-');
  textcolor(7);
  }

  fastwr_col := vumeter div 48;
  if fastwr_col < 1 then fastwr_col := 1;
  if fastwr_col > 6 then fastwr_col := 6;
  fastwr_col := flashcol[fastwr_col];
  fastwr_x := 15; fastwr_y := 0;
  fastwr_text := '-=ZSMPLAY=-'; fastwrite;


end;


procedure display_scope; assembler;
asm

          mov ax, 0a000h
          mov es, ax
          mov ax, vumeter
          or ah, ah
          jz @noclip
          mov ax, 255
          @noclip:
          lea bx, dancecol
          shr al, 6
          inc al
          add bx, 4
          sub bx, ax
          mov al, ds:[bx]
          mov ah, al
          mov di, 35*320+32
          mov cx, 128
          rep stosw
          mov di, 164*320+32
          mov cx, 128
          rep stosw

          mov cx, 128
          mov di, 36*320+31
          @loop0:
            mov es:[di], al
            add di, 257
            mov es:[di], al
            add di, 63
          dec cx
          jnz @loop0

          push bp

          lea bp, scopetext2
          inc bp
          mov bx, scopecol
          sub bx, 8
          mov ax, ds
          mov es, ax
          mov ax, 1300h
          mov cx, 10
          mov dh, 21
          mov dl, 15
          int 10h

          lea bp, scopetext
          inc bp
          mov ax, ds
          mov es, ax
          mov ax, 1300h
          mov bx, 23
          sub bx, scopecol
          mov cx, 11
          mov dh, 3
          mov dl, 14
          int 10h


  db 66h; xor cx, cx
  mov bp, scopecol
  les di, screenbuf

  mov dx, di

  db 66h; xor cx, cx
  mov cx, 128*64; db 66h; xor ax, ax
  db 66h; rep stosw { rep stosd }

  mov ax, 1300h
  db 66h; shl ax, 16
  mov ax, 1300h
  mov di, 64*256
  mov cx, 64
  db 66h; rep stosw

  mov di, dx

  push ds
  lds si, scope_ptr

 { scope hat immer 256 Werte, werden entsprechend der Puffergroesse skaliert }
  mov cx, 254; db 66h; shl cx, 16
  mov cx, di; mov dx, 0ffffh
  db 66h; shl dx, 16; mov dx, 1
  { trick mit geshiftetem zaehler -> solange carry, springen }


  @loop:

  mov di, cx
  mov ax, ds:[si]
  inc si

  db 66h; xor bx, bx

  cmp al, ah
  jb @al_below

  { linie geht von unten nach oben, also: }
  xchg al, ah { koordinaten vertauschen }

  mov bx, 0ffffh
  db 66h; shl bx, 16

  { in BX flaggen }

  @al_below:
  {line geht von oben nach unten}

  { al ist nun garantiert kleiner oder gleich ah }

  mov bl, al
  shl bx, 8  { starthoehe, d.h. al * 256 }
  add di, bx { Startposition ist gesetzt }
  mov bx, bp
  mov bh, bl
  db 66h; shr bx, 8 { bh ist nun flag }

  sub ah, al
  mov al, ah
  shr al, 1
  sub ah, al
  { senkrechte Punkte ausrechnen und zwei Teile machen}

  or ah, ah
  jnz @weiter
  inc ah
  @weiter:

  or al, al
  jz @linienloop2

  or bh, bh
  jz @linienloop
  inc di

  @linienloop:
    mov es:[di], bl
    add di, 256
  dec al
  jnz @linienloop

  or ah, ah
  jz @weiter3
  inc di
  or bh, bh
  jz @linienloop2
  dec di
  dec di
  @linienloop2:
    mov es:[di], bl
    add di, 256
  dec ah
  jnz @linienloop2

  @weiter3:


  db 66h; add cx, dx
  jc @loop
  pop ds

  pop bp


  push ds
  lds si, screenbuf
  mov ax, 0a000h
  mov es, ax

  mov bx, 128
  mov di, 36*320+32
  @loop2:
    mov cx, 64
    db 66h; rep movsw { rep movsd }
    add di, 64
  dec bx
  jnz @loop2
  pop ds
end;


procedure animate_smpact;
  var smp, col: byte;
begin
  for smp := 1 to zsmheader.sample_entries do
  if smpinfo[smp].length > 0 then
  begin
    col := pattcol[smp_playing[smp]shr 1];
    if smp_trig[smp] > 0 then begin
      if smp_playing[smp] > 0 then textbackground(smp_trig[smp])
        else textbackground(0);
      dec(smp_trig[smp]);
    end
    else textbackground(0);
    gotoxy((smp-1) mod 9 * 3 + 53, (smp-1) div 9 + 2);
    if smp_playing[smp] = 0 then
    begin
       col := 8;
       textcolor(col);
      write(smp div 10, smp mod 10)
    end
    else
    begin
     if smp_freq[smp] > 99 then smp_freq[smp] := 99;
     textcolor(col);
     write(smp_freq[smp]:2);
    end;

  end;
  textbackground(0);
end;

procedure animate_channels;
  var track: byte;
begin
  for track := 0 to maxtracks do
  if track_select[track] then
  begin
    gotoxy(56+3*(track mod 8),10+track div 8);
    textbackground(chan_trig[track]);

    if (channel_smp[track] > 0) and (channel_vol[track] > 0) then
    begin
      textcolor(pattcol[channel_vol[track]shr 1]);
      write(channel_smp[track] div 10, channel_smp[track] mod 10);
    end
    else
    begin
      textcolor(8);
      write('0', hexnyb[track]);
    end;

    if chan_trig[track] > 0 then dec(chan_trig[track]);

    textbackground(0);
  end
  else
  begin
    gotoxy(56+3*(track mod 8),10+track div 8);
    textcolor(8); write('--');
  end;

end;


procedure display_static_smpact_chn;
  var i: byte;
begin
gotoxy(52, 1);
textcolor(6); write(  ''); textcolor(12); write('S');
textcolor(6); write(''); textcolor(12); write('A');
textcolor(6); write(''); textcolor(12); write('M');
textcolor(6); write(''); textcolor(12); write('P');
textcolor(6); write(''); textcolor(12); write('L');
textcolor(6); write(''); textcolor(12); write('E');
textcolor(6); write(''); textcolor(12); write('S');
textcolor(6); write('ͻ');
for i := 0 to {(zsmheader.sample_entries-1)}62 div 9 do
begin
gotoxy(52, 2+i); write('                  ');
end;
gotoxy(52,3+i); write( '͹');
gotoxy(52,4+i); write( '                   ');
gotoxy(52,5+i); write( '                   ');
gotoxy(52,6+i); write( '   '); textcolor(12); write('C');
textcolor(6); write(''); textcolor(12); write('H');
textcolor(6); write(''); textcolor(12); write('A');
textcolor(6); write(''); textcolor(12); write('N');
textcolor(6); write(''); textcolor(12); write('N');
textcolor(6); write(''); textcolor(12); write('E');
textcolor(6); write(''); textcolor(12); write('L');
textcolor(6); write(''); textcolor(12); write('S');
textcolor(6); write('Ľ');
end;


procedure display_static_smpvalues (startsmp: byte);
  var smp, endsmp: byte;
begin
  endsmp := zsmheader.sample_entries;
  if endsmp - (startsmp - 1) > 19 then endsmp := 19 + (startsmp - 1);
  for smp := startsmp to endsmp do
  begin
    textcolor(smp and 1 + 10);
    gotoxy(2, smp-startsmp+5); write(smp:2);
    gotoxy(5, smp-startsmp+5);
    write(smpinfo[smp].length div 2 + smpinfo[smp].length and 1:5);
    gotoxy(11, smp-startsmp+5); write(smpinfo[smp].length:5);
    gotoxy(17, smp-startsmp+5);
    if smpinfo[smp].loopstart < smpinfo[smp].length then
        write(smpinfo[smp].loopstart:5)
      else write('  -  ');
  end;
end;

procedure display_static_smpdetails;
begin
  fastwr_x := 0; fastwr_y := 0;
  fastwr_rep := 80*25; fastwr_text := ' ';
  fastwrite;

  fastwr_col := 11;
  fastwr_text := 'ZSMPLAY Sample Details';
  fastwr_x := 40 - fastwr_textlen div 2;
  fastwrite;

  fastwr_text :=
    'Ŀ';
  fastwr_col := 10; fastwr_x := 0; fastwr_y := 1; fastwrite;

  textcolor(10);
  gotoxy(1,3); write(''); textcolor(12); write('no');
  textcolor(10); write(''); textcolor(12); write('size ');
  textcolor(10); write(''); textcolor(12); write(' len ');
  textcolor(10); write(''); textcolor(12); write('loops');
  textcolor(10); write(''); textcolor(12); write('i');
  textcolor(10); write(''); textcolor(12); write('freq ');
  textcolor(10); write(''); textcolor(12); write('vol');
  textcolor(10); write(''); textcolor(12); write(' playing position...');
  gotoxy(80,3); textcolor(10); write('');

  fastwr_text :=
    'Ĵ';
  fastwr_x := 0; fastwr_y := 3; fastwrite;
  fastwr_text :=
    '                                                                       ';
  for fastwr_y := 4 to 22 do begin fastwr_x := 0; fastwrite; end;
  fastwr_text :=
    '';
  fastwr_x := 0; fastwr_y := 23; fastwrite;

  display_static_smpvalues(smpdet_start);

  if zsmheader.sample_entries > 19 then
  begin
    gotoxy(3, 25); textcolor(3);
    write('more than 19 samples. use cursor keys up/down to scroll.');
  end;
end;


procedure display_static_main;
begin
  display_static_smpact_chn;

  textcolor(4);
  gotoxy(16, 1); write('-=ZSMPLAY=-');
  textcolor(3);write(' v0.04 by Zatzen 2017');
  gotoxy(13, 2); textcolor(9); write('Song Name: ', titel);
  if titel[0] = chr(0) then write ('(none)');
  gotoxy(14, 3);
  write('Composer: ', composer);
  if composer[0] = chr(0) then write('(unknown)');

  gotoxy(18,4); write('Date: ');
  if zsmheader.date_year = 0 then write('(unknown)')
  else
  begin
    if zsmheader.date_month > 0 then write(month[zsmheader.date_month],' ');
    if zsmheader.date_day > 0 then write(zsmheader.date_day);
    if (zsmheader.date_day > 0) and (zsmheader.date_year > 0) then
    write(', ');
    if zsmheader.date_year > 0 then write(zsmheader.date_year);
  end;


  {
  textcolor(2);
  gotoxy(36, 17);write('-33   -27   -21   -15   -9    -3  ');
  textcolor(6); write('0    '); textcolor(4); write('+6');
  textcolor(2);
  gotoxy(37, 18); write('                           ');
  textcolor(6); write('     '); textcolor(4);write('');
  }
  for i := 0 to 1 do begin
    gotoxy(41, 16+2*i);
    textcolor(4); write(''); textcolor(6); write('');
    textcolor(12); write('');
    textcolor(6); write(''); textcolor(4); write('');
  end;

  textcolor(3);
  gotoxy(41, 19); write('');
  textcolor(2); write(' dB');
  gotoxy(41, 20); write('                         ');
  textcolor(6); write('     '); textcolor(4); write('');
  textcolor(2);
  gotoxy(41, 21); write('    -24   -18   -12   -6     ');
  textcolor(6); write('0     '); textcolor(4); write('+6 ');

  textcolor(2);
  gotoxy(44, 4); write('Loop:');
  gotoxy(24-6, 5);
  write('Sequencer:               ',zsmheader.sequencer_loopstart, ' - ', zsmheader.sequencer_loopend);
  if not play_looped then
  begin
    gotoxy(41,6); write('deactivated');
  end;

  gotoxy(26-6, 6); write('Pattern: ');
  gotoxy(22-6, 7); write('Pattern Row: ');

  textcolor(3);
  gotoxy(12, 8); write('Offset In Patterndata: ');
  gotoxy(13, 09); write('Pattern Size (Bytes):');
  gotoxy(2, 10); write('Pattern Header & Tables (Bytes):');
  gotoxy(3, 11); write('Position in Patterndata (Byte):');
  gotoxy(3, 12); write('Avg. Bits/Row:       Bytes/Sec: ');
  textcolor(8);
  gotoxy(16, 13); write('Event Flags Bytes:');
  gotoxy(2, 14); write('Ratio:');
  textcolor(7);
  gotoxy(12, 14); write('Pure Music Data Bytes:');
  textcolor(8);
  gotoxy(1, 16);
  write('File: ', fname);

  textcolor(2); gotoxy(42, 11);
  write(' Time: ');
  gotoxy(47, 12); write('/', playing_seconds div 60:2,':',(playing_seconds mod 60)div 10, playing_seconds mod 10);
  textcolor(8);
  gotoxy(1, 17);
  writeln('Size: ', zsmfilesize, ' Bytes');
  writeln('Patterndata Size Total: ', zsmheader.patterndata_size, ' Bytes');
  writeln('Biggest Pattern: ', biggest_pattern, ' Bytes');
  writeln('Smallest Pattern: ', smallest_pattern, ' Bytes');
  writeln('Average Pattern Size: ', zsmheader.patterndata_size div number_of_patterns, ' Bytes');
{  writeln('Samples: ', zsm_realsamples);}
  writeln('Pitch Tables Size: ', ptablesize, ' Bytes');
  writeln('Sample Data: ', smpblocksize, ' Bytes');
  gotoxy (1, 24); textcolor(7); write('Patterndata Progress:');

  textcolor(3);
  gotoxy(41, 22); write('(V)olume Att.:');
  gotoxy(56, 22); textcolor(3);
  if mixvol > 0 then write('-',mixvol*6, ' dB ')
    else write ('0 dB  ');
  textcolor(7);
  gotoxy(66, 22); write('(I)nstructions');
  {textcolor(9);}
  gotoxy(41, 23); {write('0..F (un)mute Channel, Space: unmute all');}
  write('Mixing at ', 11025 * word(qfactor), ' Hz, 8 Bit Mono');
  textcolor(2);
  gotoxy(41, 24);{ write('+ - to increase/decrease Sequencer Position');}
  textcolor(7);
  write('Effective Avg. Data Rate: ');
  write(round(zsmfilesize / round(playing_time / 11025 / qfactor)), ' Bytes/s');

  gotoxy(41, 14); textcolor(9);
  write('Sample Data Processing Rate:       K/s');

end;


{
procedure display_patt;
  var
    x, t: byte;
    textcol, backcol: byte;
    eax_: longint;
    ax_: word;
    ch: char;
begin
}
{ fr direktes Schreiben in den Textspeicher: }
{memw[$b800:0000] := $2A41;} { WORD Eintrge, erst Farbe, dann Zeichen }


procedure next_messageline; assembler;
asm

  mov ax, ds
  mov es, ax
  lea di, message_line

  mov bx, msg_offset

  mov dl, msg_line { DL: Zeilennummer }
  mov dh, msg_linenum

  xor ah, ah

  push bp
  push ds
  lds si, cmsg_pointer
  mov bp, si

  or bx, bx { Wenn Offset = 0 }
  jnz @skip
  mov dh, ds:[si]; inc si { DH: Anzahl Zeilen }
  @skip:

  add si, bx

  lodsb
  or al, al
  jz @nullende

  test al, 128
  jz @nixdavor
  lodsb
  @nixdavor:
  test al, 64
  jnz @nullende2 { redundante Zeichenketten wie '-----' auch rausnehmen }

  mov cx, ax { Zeichen bertragen }
  stosb
  rep movsb
  jmp @ende

  @nullende2:
  inc si
  @nullende:
  xor al, al
  mov es:[di], al


  @ende:

  pop ds

{  sub si, bx}
{  add msg_offset, si}
  sub si, bp
  mov msg_offset, si
  mov msg_linenum, dh

  inc dl
  cmp dl, dh
  jb @skip2

    mov dl, 0
    mov msg_offset, 1

  @skip2:
  mov msg_line, dl

  pop bp

end;


procedure smpdetails_mode; { mode 3 }
  var
    smp, endsmp: byte;
    lastup: bytebool;
begin


  endsmp := zsmheader.sample_entries;
  if endsmp - (smpdet_start - 1) > 19 then endsmp := 19 + (smpdet_start - 1);
  for smp := smpdet_start to endsmp do
  begin
    textcolor(smp and 1 + 10);
    gotoxy(23, smp-smpdet_start+5);
    if smp_instances[smp]>0 then write(hexnyb[smp_instances[smp]])
      else write(' ');
    gotoxy(25, smp-smpdet_start+5);
    if smp_playing[smp] > 0 then begin
      if smp_freq_fine[smp]>99999 then write('99999') else write(smp_freq_fine[smp]:5)
      end
      else write('     ');
    gotoxy(31, smp-smpdet_start+5);
    if smp_playing[smp] > 0 then write(scaledvol[smp_playing[smp]]:3)
      else write('   ');
  end;

  for smp := smpdet_start to endsmp do
  if smpinfo[smp].length > 0 then
  begin
    fastwr_x := 34; fastwr_y := smp-smpdet_start+4;
    fastwr_text := ''; fastwr_col := pattcol[smp_playing[smp]shr 1];
    fastwr_rep := (46*longint(smp_pos_show[smp])) div smpinfo[smp].length;
    fastwrite;
    fastwr_rep := 45 - (46*longint(smp_pos_show[smp])) div smpinfo[smp].length;
    fastwr_text := ' ';
    fastwrite;

  end;



{if newpatrow then begin}

    asm mov ax, 0b00h; int 21h; mov key, al; end;
    if key then
    begin
      ch := readkey;

      i := 0;
      while (i < 16) and (upcase(ch) <> hexnyb[i]) do inc(i);
      if i < 16 then
        track_select[i] := not track_select[i];

      if ord(ch) = 32 then for i := 0 to 15 do track_select[i] := true;

      if ch = '+' then begin inc_sequ; ch := chr(255); end;
      if ch = '-' then begin dec_sequ; ch := chr(255); end;

      if ch = chr(0) then
      begin
        ch := readkey;

        if ch = chr($50) then
        begin
        if smpdet_start + 18 < zsmheader.sample_entries then
          inc(smpdet_start);
          display_static_smpvalues(smpdet_start);
        end;

        if (ch = chr($48)) then
        begin
          if smpdet_start > 1 then dec(smpdet_start);
          display_static_smpvalues(smpdet_start);
        end;

      end;

      if upcase(ch) = 'V' then
      begin
        inc(mixvol);
        if mixvol > 2 then mixvol := 0;
      end;
      if upcase(ch) = 'T' then
      begin
        fastwr_x := 0; fastwr_y := 0;
        fastwr_rep := 80*25; fastwr_text := ' ';
        fastwrite;
        display_static_main;
        mode := 1;
      end;
    end;
{end;} { if newpatrow }


end;


procedure display_static_instructions;
  var i: byte;
begin
  gotoxy(41, 1); write('         ');
  fastwr_text := '                                        ';
  fastwr_x := 0;
  fastwr_rep := 1;
  for fastwr_y := 0 to 24 do
  begin
    fastwr_x := 0;
    fastwrite;
  end;

  textcolor(7);
  gotoxy(15, 3); writeln('Instructions');
  writeln;
  writeln(' Use +/- to increase/decrease sequencer');
  writeln(' S to switch to scope mode');
  writeln(' T to show sample details');
  writeln(' Press the same key again to go back to');
  writeln(' main mode. Leave any time with Esc.');
  writeln(' 0..9 and A..F to mute/unmute channel,');
  writeln(' spacebar to unmute all.');
  writeln;
  writeln(' Samples-display in main mode shows');
  writeln(' activity of samples, with the playing');
  writeln(' frequency of each sample displayed in');
  writeln(' kHz. Channel display underneath is');
  writeln(' showing the number of the sample');
  writeln(' played on each channel.');
  writeln;
  writeln(' Effective avg. data rate is calculated');
  writeln(' by the total size of the zsm file');
  writeln(' divided by playing length in seconds.');
end;


procedure main_mode; { mode 1 }
  var bar: byte;
begin


     animate_smpact;

     animate_channels;

     display_vu;

       if zsmheader.cmsg_size > 0 then
       begin
         dec(msg_counter);
         if msg_counter = 0 then
         begin
           next_messageline;
           msg_counter := msg_len * 5+15; {Leerzeilen werden somit bersprungen (+1 -> keine Wartezeit)}
           {
           gotoxy(40, 17);
           write('                                        ');
           textcolor(12);
           }
           fastwr_x := 40; fastwr_y := 16; fastwr_text := ' ';
           fastwr_rep := 40; fastwrite;
           {gotoxy(60-msg_len div 2, 17); write(message_line);}
           fastwr_x := 60-msg_len div 2 - msg_len and 1; fastwr_y := 16;
           fastwr_text := message_line; fastwr_col := 12; fastwrite;
         end;
       end;

     if newpatrow then
     begin


       actual_seconds
       := round((sequ_time_pos^[actual_sequ]
       +actual_spl_per_row
       *longint(patternrow_act)) / 11025 / qfactor);

       gotoxy(41,12); textcolor(2);
       write(actual_seconds div 60:2,':',(actual_seconds mod 60) div 10, actual_seconds mod 10);


       traff := trunc(traffic*(22050/bsize)/102.4);
       textcolor(9);
       gotoxy(70,14); write(traff/ 10:5:1);



       fastwr_x := 40; fastwr_y := 14; fastwr_col := $09;
       if traff > 40*25 then traff := 40*25;
       fastwr_text := chr(223);
       i := traff div 25;
       fastwr_rep := i; if i > 0 then fastwrite;
       if traff mod 25 > 12 then begin
         fastwr_col := $01;
         fastwrite; inc(i);
       end;
       fastwr_rep := 40 - i;
       fastwr_text := ' '; fastwrite;





       txtcol := 20;
       fastwr_col := $84;
       if idle > 5000 then fastwr_col := $04;
       if idle > 10000 then fastwr_col := $06;
       if idle > 25000 then fastwr_col := $02;
       if idle > 50000 then fastwr_col := $0A;
       fastwr_text := 'CPU';
       fastwr_x := 35;
       fastwr_y := 22;
       fastwrite;


    textcolor(2);
    gotoxy(35-6, 5); write(actual_sequ:4, ' /', zsmheader.sequencer_entries:4);
    gotoxy(35-6, 6); write(act_pattern_number:4, ' /', number_of_patterns:4);
    gotoxy(36-6, 7); write(patternrow_act:3, ' /', patternrowstotal:4);


    textcolor(3);
    gotoxy(35, 09); write(act_pattern_size:4);
    gotoxy(34, 10); write(pattheaderandtables:5);
    gotoxy(34, 11); write(patternpos:5);


    fastwr_x := 0; fastwr_y := 24; fastwr_text := '';
    fastwr_rep := (pattheaderandtables * 80) div act_pattern_size;;
    fastwr_col := 11; fastwrite;
    bar := (patternpos * 80) div act_pattern_size;
    fastwr_rep := bar; fastwr_col := 7; fastwrite;
    fastwr_rep := 80 - bar; fastwr_text := ' '; fastwrite;

    {
    if db > 4 then begin
      inc(mixvol);
      if mixvol > 2 then mixvol := 2;
      gotoxy(59, 22); textcolor(3);
      if mixvol > 0 then write('-',mixvol*6, ' dB ') else write ('0 dB  ');
    end;
    }

    if patternpos <> lastpatpos then
    begin
      textcolor(3);
      lastpatpos := patternpos;
      gotoxy(17, 12);
        write(round(patternpos*8 / (patternrow_act+1)):3);
      gotoxy(35, 12);
        write(patternpos / (patternrow_act+1) * 22050 / actual_spl_per_row:4:1, ' ');
      gotoxy(34, 8); write(offset_in_patterndata:5);
    end;


    textcolor(8);
    gotoxy(34, 13); write(emptyflagbits div 8:5);
    textcolor(7);
    gotoxy(34, 14); write(purebits div 8:5);
    bitsum := purebits + emptyflagbits;



    if bitsum > 0 then begin
      fastwr_text := '';
      fastwr_x := 0; fastwr_y := 14;
      fastwr_col := 7; fastwr_rep := round(38 * purebits / bitsum);
      if fastwr_rep > 0 then fastwrite;
      fastwr_col := 8; fastwr_rep := 38 - round(38 * purebits / bitsum);
      fastwrite;
    end;


  end; { wenn zeilenwechsel }

    {
    fill_soundbuffer;
    sound_nextframe := false;
    idle := 0;
    repeat asm db 66h; inc word ptr idle; end; until sound_nextframe;
    }

if newpatrow then begin

    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
    begin
      ch := readkey;
      i := 0;
      while (i < 16) and (upcase(ch) <> hexnyb[i]) do inc(i);
      if i < 16 then
        track_select[i] := not track_select[i];

      if ord(ch) = 32 then for i := 0 to 15 do track_select[i] := true;

      if ch = '+' then begin inc_sequ; ch := chr(0); end;
      if ch = '-' then begin dec_sequ; ch := chr(0); end;


      if upcase(ch) = 'V' then
      begin
        inc(mixvol);
        if mixvol > 2 then mixvol := 0;
        gotoxy(56, 22); textcolor(3);
        if mixvol > 0 then write('-',mixvol*6, ' dB ')
        else write ('0 dB  ');
      end;
      if upcase(ch) = 'T' then
      begin
        display_static_smpdetails;
        mode := 3;
      end;
      if upcase(ch) = 'I' then
      begin
        display_static_instructions;
        mode := 4;
      end;
      if upcase(ch) = 'S' then
      begin
        scopemode := true;
        mode := 2;
        asm
          mov ax, 13h; int 10h
          mov ax, 0a000h
          mov es, ax
          xor di, di
          db 66h; xor ax, ax
          db 66h; xor cx, cx
          mov cx, 16000
          db 66h; rep stosw
        end;
      end;
    end;
end; { if newpatrow }



end;


procedure instructions_mode; { mode 4 }
  var bar: byte;
begin


     animate_smpact;

     animate_channels;

     display_vu;

       if zsmheader.cmsg_size > 0 then
       begin
         dec(msg_counter);
         if msg_counter = 0 then
         begin
           next_messageline;
           msg_counter := msg_len * 5+15; {Leerzeilen werden somit bersprungen (+1 -> keine Wartezeit)}
           gotoxy(40, 17);
           write('                                        ');
           textcolor(12);
           gotoxy(60-msg_len div 2, 17); write(message_line);
         end;
       end;

     if newpatrow then
     begin


       actual_seconds
       := round((sequ_time_pos^[actual_sequ]
       +actual_spl_per_row
       *longint(patternrow_act)) / 11025 / qfactor);

       gotoxy(41,12); textcolor(2);
       write(actual_seconds div 60:2,':',(actual_seconds mod 60) div 10, actual_seconds mod 10);


       traff := trunc(traffic*(22050/bsize)/102.4);
       textcolor(9);
       gotoxy(70,14); write(traff/ 10:5:1);



       fastwr_x := 40; fastwr_y := 14; fastwr_col := $09;
       if traff > 40*25 then traff := 40*25;
       fastwr_text := chr(223);
       i := traff div 25;
       fastwr_rep := i; if i > 0 then fastwrite;
       if traff mod 25 > 12 then begin
         fastwr_col := $01;
         fastwrite; inc(i);
       end;
       fastwr_rep := 40 - i;
       fastwr_text := ' '; fastwrite;





    fastwr_x := 0; fastwr_y := 24; fastwr_text := '';
    fastwr_rep := (pattheaderandtables * 80) div act_pattern_size;;
    fastwr_col := 11; fastwrite;
    bar := (patternpos * 80) div act_pattern_size;
    fastwr_rep := bar; fastwr_col := 7; fastwrite;
    fastwr_rep := 80 - bar; fastwr_text := ' '; fastwrite;


    if patternpos <> lastpatpos then
    begin
    end;


  end; { wenn zeilenwechsel }

if newpatrow then begin

    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
    begin
      ch := readkey;
      i := 0;
      while (i < 16) and (upcase(ch) <> hexnyb[i]) do inc(i);
      if i < 16 then
        track_select[i] := not track_select[i];

      if ord(ch) = 32 then for i := 0 to 15 do track_select[i] := true;

      if ch = '+' then begin inc_sequ; ch := chr(0); end;
      if ch = '-' then begin dec_sequ; ch := chr(0); end;


      if upcase(ch) = 'V' then
      begin
        inc(mixvol);
        if mixvol > 2 then mixvol := 0;
        gotoxy(56, 22); textcolor(3);
        if mixvol > 0 then write('-',mixvol*6, ' dB ')
        else write ('0 dB  ');
      end;
      if upcase(ch) = 'T' then
      begin
        display_static_smpdetails;
        mode := 3;
      end;
      if upcase(ch) = 'I' then
      begin
        clrscr;
        display_static_main;
        mode := 1;
      end;
      if upcase(ch) = 'S' then
      begin
        scopemode := true;
        mode := 2;
        asm
          mov ax, 13h; int 10h
          mov ax, 0a000h
          mov es, ax
          xor di, di
          db 66h; xor ax, ax
          db 66h; xor cx, cx
          mov cx, 16000
          db 66h; rep stosw
        end;
      end;
    end;
end; { if newpatrow }



end;


procedure scope_mode; { mode 2 }
begin



    if (patternrow_act mod 16 = 0) and scopecolchange then
    begin
      while scopecol = lastscopecol do scopecol := random(7)+9;
      lastscopecol := scopecol;
      scopecolchange := false;
    end;
    if patternrow_act mod 16 > 0 then scopecolchange := true;
    if not scope_hold then display_scope;

    {
    fill_soundbuffer;
    sound_nextframe := false;
    repeat until sound_nextframe;
    }

    asm
      mov ax, 0b00h;
      int 21h;
      mov key, al;
    end;
    if key then
    begin
      ch := readkey;

      i := 0;
      while (i < 16) and (upcase(ch) <> hexnyb[i]) do inc(i);
      if i < 16 then
        track_select[i] := not track_select[i];

      if ord(ch) = 32 then for i := 0 to 15 do track_select[i] := true;

      if ch = '+' then begin inc_sequ; ch := chr(0); end;
      if ch = '-' then begin dec_sequ; ch := chr(0); end;
      if upcase(ch) = 'V' then
      begin
        inc(mixvol);
        if mixvol > 2 then mixvol := 0;
      end;
      if upcase(ch) = 'H' then scope_hold := not scope_hold;
      if upcase(ch) = 'S' then
      begin
        mode := 1;
        scopemode := false;
        scope_hold := false;
        asm mov ax, 03h; int 10h end;
        asm mov ah, 01h; mov cx, 2607h; int 10h; end;
        display_static_main;
      end;
    end;


end;


procedure mode_jumptable; assembler;
asm
  dw 0
  dw offset main_mode
  dw offset scope_mode
  dw offset smpdetails_mode
  dw offset instructions_mode
end;

begin
  sb_base := 0; sb_irq := 0; sb_dma := 0;

  user_abort := true;
  play_looped := true;
  loopcount := 0;
  qfactor := 4;
  for i := 1 to paramcount do
  begin

    param := paramstr(i);
    for ii := 1 to param_len do param[ii] := upcase(param[ii]);
    if param = '/NOLOOP' then play_looped := false;

    if param = '/11KHZ' then qfactor := 1;
    if param = '/22KHZ' then qfactor := 2;

    param[0] := chr(8);
    if param = '/BLASTER' then
    begin
      sb_base := longint(hex2byte[ord(param[9])])*256
        +word(hex2byte[ord(param[10])])*16+hex2byte[ord(param[11])];
      sb_irq := hex2byte[ord(param[12])];
      sb_dma := hex2byte[ord(param[13])];
    end;
  end;



  mixvol := 1;
  msg_offset := 0;
{  msg_line := 255;}
  msg_counter := 100;

  fastwr_rep := 1;

  lastpatpos := 65535;
  vumeter := 0;
  ln10 := ln(10);
  fillchar (track_select, 16, $FF);

  mode := 1;
  smpdet_start := 1;
  scopemode := false;
  scopecol := 10;
  getmem(screenbuf, 256*128);

  param := paramstr(1);
  if (param = '') or (param[1] = '/') then
  begin
    writeln;
    writeln('ZSMPLAY v0.04 by Zatzen 2017');
    writeln;
    writeln('usage:'); writeln;
    writeln('ZSMPLAY <ZSMFILE> [/xxKHZ] [/BLASTERxxxxx] [/NOLOOP]');
    writeln;
    writeln('/xxKHZ: mixing samplerate, xx can be 11, 22 or 44 (default: 44)');
    writeln('/BLASTERxxxxx: override SoundBlaster autodetection, e.g. 22071 (base, irq, dma)');
    writeln('/NOLOOP: deactivate looped playback');
    writeln;
    halt(1);
    {
    write('ZSM-Datei (ohne Erw.): ');
    readln(fname);
    }
  end
  else
    fname := paramstr(1);
   if not ( fname[ord(fname[0])-4]='.') then;
     fname := fname + '.zsm';


  errcode := load_zsm(fname);
  if errcode = 1 then
  begin
    writeln('Error opening ', fname);
    halt(1);
  end;
  if errcode = 2 then
  begin
    writeln(fname, ' is not a ZSM');
    halt(1);
  end;
  if errcode = 3 then
  begin
    writeln(fname, ' is not version 4');
    halt(1);
  end;


  get_maxtracks;

  calc_pattern_sizes;


  for i := 0 to 29 do
    titel[i+1] := zsmheader.titel[i];
  i := 30;
  while (i > 0) and (titel[i] = chr(0)) do dec(i);
  titel[0] := chr(i);

  for i := 0 to 19 do
    composer[i+1] := zsmheader.composer[i];
  i := 20;
  while (i > 0) and (composer[i] = chr(0)) do dec(i);
  composer[0] := chr(i);


  adapt_zsm_pitchtables;

  clrscr;

  get_playing_time;
  playing_seconds := round(playing_time / 11025 / qfactor);

  display_static_main;

  goto_sequ(1);


  init_zsm_soundbuffer(bsize * qfactor div 2);

  if init_sound(bsize * qfactor div 2, 11025 * qfactor) > 0 then
  begin
    writeln('Error initializing Soundblaster');
    halt(1);
  end;

  asm mov ah, 01h; mov cx, 2607h; int 10h; end; { cursor verstecken }

  repeat until sound_nextframe; { Doppeltrigger am Anfang verhindern }


  newpatrow := true;
  last_newpatrow := 256;

  repeat  { Hauptschleife }

    asm
      mov bx, mode
      add bx, bx
      mov bx, cs:[bx + offset mode_jumptable]
      call bx
    end;

    fill_soundbuffer;
    sound_nextframe := false;
    idle := 0;
    repeat asm db 66h; inc word ptr idle; end; until sound_nextframe;


    if newpatrow then
      newpatrow := false
    else
      if last_newpatrow <> patternrow_act then
      begin
        newpatrow := true;
        last_newpatrow := patternrow_act;
      end;

  if not play_looped then
    if loopcount > 0 then begin ch := chr(27); user_abort := false end;


  until ch = chr(27); { Hauptschleife Ende }

  asm mov ax, 03h; int 10h end;
  asm mov ah, 01h; mov cx, 0607h; int 10h; end;
  textcolor(7);

  deinit_sound;

  clear_zsm;

  clrscr;
  if user_abort then halt(99);
end.